//+------------------------------------------------------------------+
//|                                               trailing stops.mqh |
//|                                                        Ekaterina |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Ekaterina" 
#property strict

#include <common variables.mqh>
extern int k;
//--------------------------------------------------------------- 6 --
//- trailing stop  Parabolic
void Trailing_Stop_Paraboilc()
{
  bool Ans;
  double SLnew;
  double Parabolic = iSAR(NULL,0,0.02,0.2,0);
  for (int i=0; i<=OrdersTotal();i++)
      {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
        if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
          SLnew=NormalizeDouble(Parabolic,Digits);
          StopCorrect(Symbol(),SLnew);
          if(OrderStopLoss()!=SLnew)
          Ans=OrderModify(OrderTicket(),OrderOpenPrice(),SLnew,0,0);   // !
          if (Ans==true) Print(" stoploss ",OrderTicket());    // 
          else Print("OrderModify error ",GetLastError());                  //  
         }    
      } 
     }
return;
}
// - trailing stop  -------------------------------------------------
void Trailing_Stop_extremum()
{ 
  double SLnew;
  bool Ans;
  for (int i=0; i<=OrdersTotal();i++)
   {
     if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
        if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
          {
           if (OrderType() == OP_BUY) SLnew =NormalizeDouble((GetMinimum()-Indent*Point),Digits);
           if (OrderType() == OP_SELL) SLnew =NormalizeDouble((GetMaximum()+Indent*Point),Digits); 
           StopCorrect(Symbol(),SLnew);
           if(OrderStopLoss()!=SLnew)
           Ans=OrderModify(OrderTicket(),OrderOpenPrice(),SLnew,0,0);   // !
           if (Ans==true) Print(" stoploss ",OrderTicket());    // 
           else Print("OrderModify error ",GetLastError());                  //        
        }
      } 
    }
  return;
}
// -      ---------------------------
double GetMaximum()
{
    int MaxValueIndex;
    double Maximum; 
    MaxValueIndex = ArrayMaximum (High,k,1);
    Maximum = High[MaxValueIndex];
    return(Maximum);
}
// -      ------------------------------
double GetMinimum()
{
    int MinValueIndex;
    double Minimum; 
    MinValueIndex = ArrayMinimum (Low,k,1);
    Minimum = Low[MinValueIndex];
    return(Minimum);
}
//--  SL  stoplevel----------------------------------------
double StopCorrect(string symbol, double Stop)
  {
   double CorrStop, Extrem_Stop;
   Extrem_Stop = MarketInfo(symbol, MODE_STOPLEVEL)*Point;          
   if(Stop < Extrem_Stop) CorrStop = Extrem_Stop;
   else  CorrStop = Stop; 
   return(CorrStop);
  } 
//- simple trailing stop---------------------------------------------------------+
void Trailing_Stop()
{
 double TDistance = TS*Point;              
 double TStep =SL*Point;
 double SLnew; 
 bool Ans;
 for (int i=0; i<=OrdersTotal();i++)
     {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
          if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
            {
            if(OrderType()==OP_BUY)
              {
                if (Bid-OrderOpenPrice()>TDistance)
                 {
                  if (OrderStopLoss()<Bid-(TDistance+TStep))
                    {
                     SLnew =NormalizeDouble(Bid-TStep,Digits); //  StopLoss
                     StopCorrect(Symbol(),SLnew);
                     if(OrderStopLoss()!=SLnew)
                     Ans=OrderModify(OrderTicket(),OrderOpenPrice(),SLnew,0,0);   // !
                     if (Ans==true) Print(" stoploss ",OrderTicket());    // 
                     else Print("OrderModify error ",GetLastError());                  //        
                    }
              }
           }
          if (OrderType()==OP_SELL)
           {
            if (OrderOpenPrice()-Ask>TDistance)
              {
               if (OrderStopLoss()>Ask+(TDistance+TStep))
                {
                 SLnew =NormalizeDouble(Ask+TStep,Digits); //  StopLoss
                 StopCorrect(Symbol(),SLnew);
                 if(OrderStopLoss()!=SLnew)
                 Ans=OrderModify(OrderTicket(),OrderOpenPrice(),SLnew,0,0);   // !
                 if (Ans==true) Print(" stoploss ",OrderTicket());    // 
                 else Print("OrderModify error ",GetLastError());                  //        
                }
              }
             }
          }
       }
   }
 return;
} 